DMParser Class Reference

the main class to read a DocMake file More...

`#include <DMParser.hxx>`

Inheritance diagram for DMParser:

## Public Member Functions

| DMParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor More...
virtual | ~DMParser ()
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false)
| checks if the document header is correct (or not) More...
void | parse (WPXDocumentInterface *documentInterface)
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
void | setVersion (int vers)
| sets the works version More...

## Protected Member Functions

void | init ()
| inits all internal variables More...
void | createDocument (WPXDocumentInterface *documentInterface)
| creates the listener which will be associated to the document More...
Vec2f | getPageLeftTop () const
| returns the page left top point ( in inches) More...
void | newPage (int number)
| adds a new page More...
bool | createZones ()
| finds the different objects zones More...
bool | readPictInfo (MWAWEntry const &entry)
| try to read a pict info zone ? ( resource pInf ) More...
bool | readSTwD (MWAWEntry const &entry)
| try to read an unknown zone ( resource sTwD ) More...
bool | readXtr2 (MWAWEntry const &entry)
| try to read an unknown zone ( resource xtr2 ) More...
bool | sendPicture (int zId, int lId, double lineW)
| try to send a picture knowing zId and local id More...
void | flushExtra ()
| sends the data which have not yet been sent to the listener More...
MWAWInputStreamPtr | rsrcInput ()
| return the input input More...
libmwaw::DebugFile & | rsrcAscii ()
| a DebugFile used to write what we recognize when we parse the document in rsrc More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr state)
| constructor using a state More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWContentListenerPtr & | getListener ()
| returns the listener More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
void | setListener (MWAWContentListenerPtr &listener)
| sets the listener More...
void | resetListener ()
| resets the listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
void | setFontConverter (MWAWFontConverterPtr fontConverter)
| sets the font convertor More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes

shared_ptr < DMParserInternal::State > | m_state
| the state More...
shared_ptr< DMText > | m_textParser
| the text parser More...

## Friends

class | DMText

## Detailed Description

the main class to read a DocMake file

## Constructor & Destructor Documentation

DMParser::DMParser | ( | MWAWInputStreamPtr | input,
|  | MWAWRSRCParserPtr | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

DMParser::~DMParser | ( |  | ) |

virtual

destructor

## Member Function Documentation

bool DMParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |

virtual

checks if the document header is correct (or not)

no data fork, may be ok, but this means that the file contains no text, so...

Implements MWAWParser.

Referenced by parse().

void DMParser::createDocument | ( | WPXDocumentInterface * | documentInterface | ) |

protected

creates the listener which will be associated to the document

Referenced by parse().

bool DMParser::createZones | ( |  | ) |

protected

finds the different objects zones

Referenced by parse().

void DMParser::flushExtra | ( |  | ) |

protected

sends the data which have not yet been sent to the listener

Referenced by parse().

Vec2f DMParser::getPageLeftTop | ( |  | ) | const

protected

returns the page left top point ( in inches)

void DMParser::init | ( |  | ) |

protected

inits all internal variables

Referenced by DMParser().

void DMParser::newPage | ( | int | number | ) |

protected

adds a new page

Referenced by DMText::sendMainText(), and DMText::sendText().

void DMParser::parse | ( | WPXDocumentInterface * | documentInterface | ) |

virtual

virtual function used to parse the input

Implements MWAWParser.

bool DMParser::readPictInfo | ( | MWAWEntry const & | entry | ) |

protected

try to read a pict info zone ? ( resource pInf )

Referenced by createZones().

bool DMParser::readSTwD | ( | MWAWEntry const & | entry | ) |

protected

try to read an unknown zone ( resource sTwD )

Referenced by createZones().

bool DMParser::readXtr2 | ( | MWAWEntry const & | entry | ) |

protected

try to read an unknown zone ( resource xtr2 )

Referenced by createZones().

libmwaw::DebugFile & DMParser::rsrcAscii | ( |  | ) |

protected

a DebugFile used to write what we recognize when we parse the document in rsrc

Referenced by createZones(), DMText::readFontNames(), DMText::readFooter(), readPictInfo(), readSTwD(), DMText::readStyles(), DMText::readTOC(), DMText::readWindows(), readXtr2(), and DMText::sendText().

MWAWInputStreamPtr DMParser::rsrcInput | ( |  | ) |

protected

return the input input

Referenced by DMText::computeNumPages(), DMText::readFontNames(), DMText::readFooter(), readPictInfo(), readSTwD(), DMText::readStyles(), DMText::readTOC(), DMText::readWindows(), readXtr2(), DMText::sendComment(), DMText::sendFooter(), sendPicture(), DMText::sendText(), and DMText::updatePageSpanList().

bool DMParser::sendPicture | ( | int | zId,
|  | int | lId,
|  | double | lineW
| ) |  |

protected

try to send a picture knowing zId and local id

Referenced by DMText::sendText().

## Friends And Related Function Documentation

friend class DMText

friend

Referenced by init().

## Member Data Documentation

shared_ptr<DMParserInternal::State> DMParser::m_state

protected

the state

Referenced by checkHeader(), createDocument(), createZones(), flushExtra(), init(), newPage(), readPictInfo(), and sendPicture().

shared_ptr<DMText> DMParser::m_textParser

protected

the text parser

Referenced by createDocument(), createZones(), init(), parse(), and sendPicture().

The documentation for this class was generated from the following files:

- DMParser.hxx
- DMParser.cxx